/*
 * Copyright (c) 2009 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION.
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef __PLATFORM_CONFIG_H_
#define __PLATFORM_CONFIG_H_

#include "xparameters.h"

/* ethernet controller base address */
#ifdef XPAR_AXIETHERNET_0_BASEADDR
#define PLATFORM_EMAC_BASEADDR  XPAR_AXIETHERNET_0_BASEADDR
#elif XPAR_LLTEMAC_0_BASEADDR
#define PLATFORM_EMAC_BASEADDR  XPAR_LLTEMAC_0_BASEADDR
#elif XPAR_ETHERNET_BASEADDR
#define PLATFORM_EMAC_BASEADDR  XPAR_ETHERNET_BASEADDR
#elif XPAR_EMACLITE_0_BASEADDR
#define PLATFORM_EMAC_BASEADDR XPAR_EMACLITE_0_BASEADDR
#else
#error
#endif

/* timer configuration */
#ifdef __MICROBLAZE__
#define PLATFORM_TIMER_BASEADDR XPAR_TMRCTR_0_BASEADDR
#define PLATFORM_TIMER_INTERRUPT_INTR XPAR_INTC_0_TMRCTR_0_VEC_ID
#define PLATFORM_TIMER_INTERRUPT_MASK (1 << PLATFORM_TIMER_INTERRUPT_INTR)
#endif

#if XUARTNS550
#include "xuartns550_l.h"
#else
#include "xuartlite.h"
#endif

#if XUARTNS550
#ifndef UART_BASEADDR
#define UART_BASEADDR XPAR_UARTNS550_0_BASEADDR
#endif
#define UART_CLOCK    XPAR_UARTNS550_0_CLOCK_FREQ_HZ
#define UART_BAUDRATE 9600
#endif

#if defined(XPAR_GP_8BIT_MB2PB_BASEADDR)
#define LED_BASE XPAR_GP_8BIT_MB2PB_BASEADDR
#elif defined(XPAR_LEDS_8BIT_BASEADDR)
#define LED_BASE XPAR_LEDS_8BIT_BASEADDR
#elif defined(XPAR_LEDS_4BIT_BASEADDR)
#define LED_BASE XPAR_LEDS_4BIT_BASEADDR
#elif defined(XPAR_LEDS_6BIT_BASEADDR)
#define LED_BASE XPAR_LEDS_6BIT_BASEADDR
#else
#define NO_GPIOS
#endif

#if defined(XPAR_DIPS_4BIT_BASEADDR)
#define DIP_BASE XPAR_DIPS_4BIT_BASEADDR
#elif defined(XPAR_DIP_SWITCHES_8BIT_BASEADDR)
#define DIP_BASE XPAR_DIP_SWITCHES_8BIT_BASEADDR
#elif defined(XPAR_DIP_SWITCHES_4BIT_BASEADDR)
#define DIP_BASE XPAR_DIP_SWITCHES_4BIT_BASEADDR
#elif defined(XPAR_PUSH_BUTTONS_POSITION_BASEADDR)
#define DIP_BASE XPAR_PUSH_BUTTONS_POSITION_BASEADDR
#endif

#ifndef __MICROBLAZE__
#define CACHEABLE_REGION_MASK 0xc0000001
#endif

#define PRINT_OUTPUT (1)
#define PRINT_RGB (1)
#define UTIASPEDK_FPGA_3S700AN (1)

#define UTIASPEDK_FRAME_BUFFER_BASE_ADDR (0xCF000000)

#define UTIASPEDK_RGB565_XGA75_1024_768_70HZ (1)
//#define UTIASPEDK_RGB565_XGA83_1280_792_60HZ  (1)
//#define UTIASPEDK_RGB565_XGA75_1920_1080I_60HZ (1)

#ifdef UTIASPEDK_RGB565_XGA106_1440_900_60HZ
#define VIDEO_X_RES 1440
#define VIDEO_Y_RES 900
#endif

#ifdef UTIASPEDK_RGB565_XGA75_1024_768_70HZ
#define VIDEO_X_RES 1024
#define VIDEO_Y_RES 768
#endif

#ifdef UTIASPEDK_RGB565_XGA83_1280_792_60HZ
#define VIDEO_X_RES 1280
#define VIDEO_Y_RES 792
#endif

#ifdef UTIASPEDK_RGB565_XGA75_1920_1080I_60HZ
#define VIDEO_X_RES 1920
#define VIDEO_Y_RES 1080
#endif


#endif // __PLATFORM_CONFIG_H_
