// DISCLAIMER OF LIABILITY
// 
// This text/file contains proprietary, confidential
// information of Xilinx, Inc., is distributed under license
// from Xilinx, Inc., and may be used, copied and/or
// disclosed only pursuant to the terms of a valid license
// agreement with Xilinx, Inc. Xilinx hereby grants you a 
// license to use this text/file solely for design, simulation, 
// implementation and creation of design files limited 
// to Xilinx devices or technologies. Use with non-Xilinx 
// devices or technologies is expressly prohibited and 
// immediately terminates your license unless covered by
// a separate agreement.
//
// Xilinx is providing this design, code, or information 
// "as-is" solely for use in developing programs and 
// solutions for Xilinx devices, with no obligation on the 
// part of Xilinx to provide support. By providing this design, 
// code, or information as one possible implementation of 
// this feature, application or standard, Xilinx is making no 
// representation that this implementation is free from any 
// claims of infringement. You are responsible for 
// obtaining any rights you may require for your implementation. 
// Xilinx expressly disclaims any warranty whatsoever with 
// respect to the adequacy of the implementation, including 
// but not limited to any warranties or representations that this
// implementation is free from claims of infringement, implied 
// warranties of merchantability or fitness for a particular 
// purpose.
//
// Xilinx products are not intended for use in life support
// appliances, devices, or systems. Use in such applications is
// expressly prohibited.
//
// Any modifications that are made to the Source Code are 
// done at the user's sole risk and will be unsupported.
//
//
// Copyright (c) 2007 - 2009 Xilinx, Inc. All rights reserved.
//
// This copyright and support notice must be retained as part 
// of this text at all times. 
//
//******************************************************************************/
// Filename            : fir_2d.c
// $Revision:: 4460   $: Revision of last commit
// $Date:: 2008-11-06#$: Date of last commit
// Description         : C file for RGB 2D FIR Menu
//******************************************************************************/

#include <stdlib.h>
#include "fir_2d.h"
#include "os_config.h"

void vsk_load_fir_2d_coefficients (int *coeffs)
{
/*
  int i;

  xc_status_t status;
  static xc_iface_t *iface;
  static xc_shram_t *shram; // coef_buffer
  static int init_done = 0;

  // initialize the software driver
  if (!init_done)
  {
	xc_create(&iface, &RGB_2D_FIR_PLBW_ConfigTable[RGB_2D_FIR_ID]);

	// obtain the memory location for storing the settings of shared memories
	xc_get_shmem(iface, "coef_buffer", (void **) &shram);
	init_done = 1;
  }

  status = XC_FAILURE;
  for (i=0; i<9; i++)
  {
      // write value to the shared memory
      status = xc_write(iface, xc_get_addr(shram->addr, i), (const unsigned) coeffs[i]); 
      if (status == XC_FAILURE) {
        print("Error Writing to RGB_2D_FIR/COEF_BUFFER\n\r");
        return;
      }
  }
*/
}


void vsk_load_fir_2d_gain (Xint32 the_gain)
{
/*
  xc_status_t status = XC_FAILURE;
  static xc_iface_t *iface;
  static xc_to_reg_t *cg_reg; // coef_gain
  static int init_done = 0;

  // initialize the software driver, assuming the Pcore device ID is 0
  if (!init_done)
  {
	xc_create(&iface, &RGB_2D_FIR_PLBW_ConfigTable[RGB_2D_FIR_ID]);

	// obtain the memory location for storing the settings of the to-regs
	xc_get_shmem(iface, "coef_gain", (void **) &cg_reg);
	init_done = 1;
  }
  
  // write value to the "din" port of the to-reg
  status = xc_write(iface, cg_reg->din, the_gain); 
  if (status == XC_FAILURE) {
     print("Error Writing to RGB_2D_FIR_COEF_GAIN\n\r");
     return;
  }
*/
}

/*
static int identity_coef[] = {
     0,  0,  0,
     0,  1,  0, 
     0,  0,  0
};
*/

void vsk_load_fir_identity(void)
{
/*
     vsk_load_fir_2d_coefficients(identity_coef);
     vsk_load_fir_2d_gain(131072);
*/
}

void vsk_disable_fir_2d_coef_update(void)
{
/*
  xc_status_t status = XC_FAILURE;
  static xc_iface_t *iface;
  static xc_to_reg_t *cu_reg; // coef_update
  static int init_done = 0;

  // initialize the software driver, assuming the Pcore device ID is 0
  if (!init_done)
  {
	xc_create(&iface, &RGB_2D_FIR_PLBW_ConfigTable[RGB_2D_FIR_ID]);

	// obtain the memory location for coef_update
	xc_get_shmem(iface, "coef_update", (void **) &cu_reg);
	init_done = 1;
  }

  // Disable update
  status = xc_write(iface, cu_reg->din, 0); 
  if(status == XC_FAILURE) { print("Error Writing to RGB_2D_FIR/COEF_UPDATE\n\r"); return; }
*/
}

void vsk_enable_fir_2d_coef_update(void)
{
/*
  xc_status_t status = XC_FAILURE;
  static xc_iface_t *iface;
  static xc_to_reg_t *cu_reg; // coef_update
  static int init_done = 0;

  // initialize the software driver, assuming the Pcore device ID is 0
  if (!init_done)
  {
	xc_create(&iface, &RGB_2D_FIR_PLBW_ConfigTable[RGB_2D_FIR_ID]);

	// obtain the memory location for coef_update
	xc_get_shmem(iface, "coef_update", (void **) &cu_reg);
	init_done = 1;
  }

  // Enable update
  status = xc_write(iface, cu_reg->din, 1); 
  if(status == XC_FAILURE) { print("Error Writing to RGB_2D_FIR/COEF_UPDATE\n\r"); return; }
*/
}


/*
static int auto_coef[] = {
     -2,  -2,  -2,
     -2,   0,  -2, 
     -2,  -2,  -2
};
*/

/* A crude flag to indicate that another thread wishes to be in charge now,
 * setting this to FALSE (presumably by another thread) will exit the loop in
 * vsk_load_fir_auto(). NOTE: Consider sem_trywait()
 */
volatile int autocoeff_continue;

/* Cycle through coefficients "automatically".
 * Continues until a different coefficient is specifically chosen by the user.
 */
void vsk_load_fir_auto(void)
{
/*
    int   gain;
    float gainf;
    int   updown;
    int   x;
    
    updown = 1;
    while (autocoeff_continue) {
        x = abs(auto_coef[4] - 16);
        gainf = (-0.5 * (float)x) / ((float)x + 2.2857) + 0.5;
        gain = gainf * 131072.0;
        vsk_load_fir_2d_coefficients(auto_coef);
        vsk_load_fir_2d_gain(gain);
        if (updown) {
            auto_coef[4]++;
            if (auto_coef[4] >= 64) {
                updown = !updown;
            }
        } else {
            auto_coef[4]--;
            if (auto_coef[4] <= 0) {
                updown = !updown;
            }
        }
        sleep(SYSTMR_CLK_FREQ_KHZ / 700);
    }
*/
}

//////////////////////////////////////////////////////////////////////////////
// Utilities
//////////////////////////////////////////////////////////////////////////////

Xfloat64 UFix20_17_to_double(Xuint32 val)
{
  Xfloat64 out;
  Xfloat64 temp;
  temp = 131072.0;
  out = temp/131072.0;
  return out;
}

Xuint32 double_to_UFix20_17(Xfloat64 val) 
{
 	// Convert float to xfix, and compute the reciprocal
	// 2^17 = 131072
	Xuint32 out;
	out = val*131072;
	return out;
}

// Scaled by 1000000, used to convert ufix20_17 to string 7 sig fig.
static const Xuint32 binptLut[17] = {
  5000000, 2500000, 1250000, 625000, 312500, 156250, 
  78125, 39062, 19531, 9765, 4882, 2441, 1220, 610,
  305, 152, 76};
static const Xuint32 VOPMSB = 0x80000000;
static const Xuint32 VOPBINPTMASK=0xFFFE0000; 

void print_UFix20_17(Xuint32 i){
  Xint32 l;
  Xint32 x = 1000000;
  Xuint32 t;
  Xuint32 binpt;	
  binpt = i << 15;
  t=0;
  for (l=0;l<16;l++){
    if ((VOPMSB & binpt)!=0) {
      t = t + binptLut[l];
      }
    binpt = binpt << 1;
  }
  xil_printf("%d.",(VOPBINPTMASK & i)>>17); 
  if(t>0) { while (t < x) { print("0"); x=x/10; } }
  xil_printf("%d",t);  
}

//---- sign exted a val to a given width
Xint32 signExtInt(Xint32 val,Xint32 width) 
{
  Xint32 pad;
  Xint32 mask;
  Xint32 out;
  mask = 1 << (width-1);
  if ((mask & val) > 0) {
    pad = 0xFFFFFFFF << width;
    out = (val | pad);
  } else {
    out = val;
  }
  return out;
}

